#include <stdio.h>
#include <stdlib.h>

/* system dependent macros */
#ifdef SGI
#define READ_DIMEN_PPRN read_dimen_pprn_
#define READ_FORMAT_PPRN read_format_pprn_
#endif
#ifdef LINUX
#define READ_DIMEN_PPRN read_dimen_pprn__
#define READ_FORMAT_PPRN read_format_pprn__
#endif
#ifdef ALPHA
#define READ_DIMEN_PPRN read_dimen_pprn_
#define READ_FORMAT_PPRN read_format_pprn_
#endif
#ifdef SUN
#define READ_DIMEN_PPRN read_dimen_pprn_
#define READ_FORMAT_PPRN read_format_pprn_
#endif
#ifdef HP
#define READ_DIMEN_PPRN read_dimen_pprn
#define READ_FORMAT_PPRN read_format_pprn
#endif

/* macros */
#define ALLOC(ptr,ne,type) if (!((ptr)= (type *)calloc((ne),sizeof(type)))) \
                     {fprintf(stderr, "calloc failed\n"); exit(-1);} 

#define REALLOC(ptr,n,type) (ptr)= (type *)realloc(((char *)ptr),(n)*sizeof(type))

/* prototipus */
void ipnet_min(int *, int *, int *, int *, int *, int *, int *, 
		 double *, double *, double *, double *, double *, 
		 double *, int *, int *, int *, double *, double *, 
		 double *, double *, int *, int *, double *, int *);

void READ_DIMEN_PPRN(int *, int *, int *, int *, int *); 

void READ_FORMAT_PPRN(int *, int *, int *, int *, int *, double *, double *,
		      double *, double *, double *, double *, double *, 
		      int *, int *, int *, int *, int *);

void main(int argc, char *argv[])
{
  int i,nar,nat,nnu,ncb,nlb,*mnk,*mnl,*arccb,*artcb,*numcb,it,cgit,iexit;
  double *kap,*cost,*cmt,*inj,*lowcb,*upcb,*coefcb,*flux,inf,fobj,epscg;

  
  /* lectura del problema multiarticle en format PPRN */
  /*  scanf("%d %d %d %d %d\n", &nnu, &nar, &nat, &ncb, &nlb); */
  READ_DIMEN_PPRN(&nnu,&nar,&nat,&ncb,&nlb);

  if (ncb == 0) nlb=0;
  ALLOC(mnk,nar,int);
  ALLOC(mnl,nar,int);
  ALLOC(kap,nar*nat,double);
  ALLOC(cost,nar*nat,double);
  ALLOC(cmt,nar,double);
  ALLOC(inj,nnu*nat,double);
  if (ncb>0) {
    ALLOC(lowcb,ncb,double);
    ALLOC(upcb,ncb,double);
    ALLOC(arccb,nlb,int);
    ALLOC(artcb,nlb,int);
    ALLOC(numcb,nlb,int);
    ALLOC(coefcb,nlb,double);
  }
  ALLOC(flux,nar*nat,double);
  
  READ_FORMAT_PPRN(&nnu,&nar,&nat,&ncb,&nlb,cost,kap,cmt,inj,lowcb,upcb,
		   coefcb,arccb,artcb,numcb,mnk,mnl);
  if (ncb>0) {
    REALLOC(arccb,nlb,int);
    REALLOC(artcb,nlb,int);
    REALLOC(numcb,nlb,int);
    REALLOC(coefcb,nlb,double);
  }

  /* les dades llegides en numeracio fortran les passem a numeracio C */
  for(i=0;i<nar;i++) {
    mnk[i]--;
    mnl[i]--;
  }
  for(i=0;i<nlb;i++) {
    arccb[i]--;
    artcb[i]--;
    numcb[i]--;
  }

  /* call to ipnet_min */
  inf= 1.0e+32;
  epscg= -1.0;
  ipnet_min(&nar,&nat,&nnu,&ncb,&nlb,mnk,mnl,kap,cost,cmt,inj,lowcb,upcb,
	    arccb,artcb,numcb,coefcb,flux,&inf,&fobj,&it,&cgit,&epscg,&iexit);
  exit(0);
}

